Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50158)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50159)
@@ -2282,19 +2312,19 @@
     mov al, byte [bp-00eh]                    ; 8a 46 f2
     cmp AL, strict byte 001h                  ; 3c 01
-    jc short 0215eh                           ; 72 0c
-    jbe short 02166h                          ; 76 12
+    jc short 02173h                           ; 72 0c
+    jbe short 0217bh                          ; 76 12
     cmp AL, strict byte 003h                  ; 3c 03
-    je short 0216eh                           ; 74 16
+    je short 02183h                           ; 74 16
     cmp AL, strict byte 002h                  ; 3c 02
-    je short 0216ah                           ; 74 0e
-    jmp short 021abh                          ; eb 4d
+    je short 0217fh                           ; 74 0e
+    jmp short 021c0h                          ; eb 4d
     test al, al                               ; 84 c0
-    jne short 021abh                          ; 75 49
+    jne short 021c0h                          ; 75 49
     mov BL, strict byte 01eh                  ; b3 1e
-    jmp short 02170h                          ; eb 0a
+    jmp short 02185h                          ; eb 0a
     mov BL, strict byte 026h                  ; b3 26
-    jmp short 02170h                          ; eb 06
+    jmp short 02185h                          ; eb 06
     mov BL, strict byte 067h                  ; b3 67
-    jmp short 02170h                          ; eb 02
+    jmp short 02185h                          ; eb 02
     mov BL, strict byte 070h                  ; b3 70
     mov al, bl                                ; 88 d8
@@ -2302,10 +2332,10 @@
     ; inc al                                    ; fe c0
     xor ah, ah                                ; 30 e4
-    call 0165ch                               ; e8 e3 f4
+    call 0165ch                               ; e8 ce f4
     xor ah, ah                                ; 30 e4
     mov dx, ax                                ; 89 c2
     sal dx, 008h                              ; c1 e2 08
     movzx ax, bl                              ; 0f b6 c3
-    call 0165ch                               ; e8 d6 f4
+    call 0165ch                               ; e8 c1 f4
     xor ah, ah                                ; 30 e4
     add ax, dx                                ; 01 d0
@@ -2314,5 +2344,5 @@
     add AL, strict byte 002h                  ; 04 02
     xor ah, ah                                ; 30 e4
-    call 0165ch                               ; e8 c6 f4
+    call 0165ch                               ; e8 b1 f4
     xor ah, ah                                ; 30 e4
     mov word [bp-036h], ax                    ; 89 46 ca
@@ -2320,17 +2350,17 @@
     add AL, strict byte 007h                  ; 04 07
     xor ah, ah                                ; 30 e4
-    call 0165ch                               ; e8 b8 f4
+    call 0165ch                               ; e8 a3 f4
     xor ah, ah                                ; 30 e4
     mov word [bp-032h], ax                    ; 89 46 ce
-    jmp short 021b8h                          ; eb 0d
+    jmp short 021cdh                          ; eb 0d
     mov bx, word [bp-020h]                    ; 8b 5e e0
     mov cx, si                                ; 89 f1
     mov dx, ss                                ; 8c d2
     lea ax, [bp-036h]                         ; 8d 46 ca
-    call 0532ch                               ; e8 74 31
-    mov bx, 00da6h                            ; bb a6 0d
+    call 0534bh                               ; e8 7e 31
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 09 f7
+    call 018e1h                               ; e8 09 f7
     mov ax, word [bp-032h]                    ; 8b 46 ce
     push ax                                   ; 50
@@ -2348,5 +2378,5 @@
     push 0012dh                               ; 68 2d 01
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 23 f7
+    call 01922h                               ; e8 23 f7
     add sp, strict byte 00014h                ; 83 c4 14
     movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
@@ -2381,9 +2411,9 @@
     mov al, byte [bp-00eh]                    ; 8a 46 f2
     cmp AL, strict byte 002h                  ; 3c 02
-    jnc short 022a7h                          ; 73 60
+    jnc short 022bch                          ; 73 60
     test al, al                               ; 84 c0
-    jne short 02250h                          ; 75 05
+    jne short 02265h                          ; 75 05
     mov di, strict word 0003dh                ; bf 3d 00
-    jmp short 02253h                          ; eb 03
+    jmp short 02268h                          ; eb 03
     mov di, strict word 0004dh                ; bf 4d 00
     mov dx, word [bp-024h]                    ; 8b 56 dc
@@ -2404,7 +2434,7 @@
     xor al, al                                ; 30 c0
     xor ah, ah                                ; 30 e4
-    jmp short 02291h                          ; eb 05
+    jmp short 022a6h                          ; eb 05
     cmp ah, 00fh                              ; 80 fc 0f
-    jnc short 0229fh                          ; 73 0e
+    jnc short 022b4h                          ; 73 0e
     movzx bx, ah                              ; 0f b6 dc
     mov es, dx                                ; 8e c2
@@ -2413,5 +2443,5 @@
     db  0feh, 0c4h
     ; inc ah                                    ; fe c4
-    jmp short 0228ch                          ; eb ed
+    jmp short 022a1h                          ; eb ed
     neg al                                    ; f6 d8
     mov es, dx                                ; 8e c2
@@ -2424,5 +2454,5 @@
     inc byte [bp-006h]                        ; fe 46 fa
     cmp byte [bp-010h], 003h                  ; 80 7e f0 03
-    jne near 0235ch                           ; 0f 85 98 00
+    jne near 02371h                           ; 0f 85 98 00
     movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
     imul ax, ax, strict byte 00018h           ; 6b c0 18
@@ -2441,10 +2471,10 @@
     mov ax, word [bp-028h]                    ; 8b 46 d8
     mov dx, es                                ; 8c c2
-    call 01ceah                               ; e8 ec f9
+    call 01cffh                               ; e8 ec f9
     test ax, ax                               ; 85 c0
-    je short 0230dh                           ; 74 0b
+    je short 02322h                           ; 74 0b
     push 00154h                               ; 68 54 01
     push strict byte 00007h                   ; 6a 07
-    call 0190dh                               ; e8 03 f6
+    call 01922h                               ; e8 03 f6
     add sp, strict byte 00004h                ; 83 c4 04
     mov cl, byte [bp-0025fh]                  ; 8a 8e a1 fd
@@ -2475,7 +2505,7 @@
     mov al, byte [bp-010h]                    ; 8a 46 f0
     cmp AL, strict byte 003h                  ; 3c 03
-    je short 0238fh                           ; 74 2c
+    je short 023a4h                           ; 74 2c
     cmp AL, strict byte 002h                  ; 3c 02
-    jne near 023f2h                           ; 0f 85 89 00
+    jne near 02407h                           ; 0f 85 89 00
     movzx bx, byte [bp-00eh]                  ; 0f b6 5e f2
     imul bx, bx, strict byte 00018h           ; 6b db 18
@@ -2489,5 +2519,5 @@
     shr word [bp-02eh], 1                     ; d1 6e d2
     rcr word [bp-030h], 1                     ; d1 5e d0
-    loop 02387h                               ; e2 f8
+    loop 0239ch                               ; e2 f8
     movzx dx, byte [bp-001bfh]                ; 0f b6 96 41 fe
     sal dx, 008h                              ; c1 e2 08
@@ -2495,17 +2525,17 @@
     or dx, ax                                 ; 09 c2
     mov byte [bp-012h], 00fh                  ; c6 46 ee 0f
-    jmp short 023adh                          ; eb 09
+    jmp short 023c2h                          ; eb 09
     dec byte [bp-012h]                        ; fe 4e ee
     cmp byte [bp-012h], 000h                  ; 80 7e ee 00
-    jbe short 023bah                          ; 76 0d
+    jbe short 023cfh                          ; 76 0d
     movzx cx, byte [bp-012h]                  ; 0f b6 4e ee
     mov ax, strict word 00001h                ; b8 01 00
     sal ax, CL                                ; d3 e0
     test dx, ax                               ; 85 c2
-    je short 023a4h                           ; 74 ea
+    je short 023b9h                           ; 74 ea
     xor di, di                                ; 31 ff
-    jmp short 023c3h                          ; eb 05
+    jmp short 023d8h                          ; eb 05
     cmp di, strict byte 00014h                ; 83 ff 14
-    jnl short 023d8h                          ; 7d 15
+    jnl short 023edh                          ; 7d 15
     mov si, di                                ; 89 fe
     add si, di                                ; 01 fe
@@ -2515,27 +2545,27 @@
     mov byte [bp+si-05fh], al                 ; 88 42 a1
     inc di                                    ; 47
-    jmp short 023beh                          ; eb e6
+    jmp short 023d3h                          ; eb e6
     mov byte [bp-038h], 000h                  ; c6 46 c8 00
     mov di, strict word 00027h                ; bf 27 00
-    jmp short 023e6h                          ; eb 05
+    jmp short 023fbh                          ; eb 05
     dec di                                    ; 4f
     test di, di                               ; 85 ff
-    jle short 023f2h                          ; 7e 0c
+    jle short 02407h                          ; 7e 0c
     cmp byte [bp+di-060h], 020h               ; 80 7b a0 20
-    jne short 023f2h                          ; 75 06
+    jne short 02407h                          ; 75 06
     mov byte [bp+di-060h], 000h               ; c6 43 a0 00
-    jmp short 023e1h                          ; eb ef
+    jmp short 023f6h                          ; eb ef
     mov al, byte [bp-010h]                    ; 8a 46 f0
     cmp AL, strict byte 003h                  ; 3c 03
-    je short 02455h                           ; 74 5c
+    je short 0246ah                           ; 74 5c
     cmp AL, strict byte 002h                  ; 3c 02
-    je short 02406h                           ; 74 09
+    je short 0241bh                           ; 74 09
     cmp AL, strict byte 001h                  ; 3c 01
-    je near 024bch                            ; 0f 84 b9 00
-    jmp near 024dbh                           ; e9 d5 00
+    je near 024d1h                            ; 0f 84 b9 00
+    jmp near 024f0h                           ; e9 d5 00
     cmp byte [bp-008h], 000h                  ; 80 7e f8 00
-    je short 02411h                           ; 74 05
+    je short 02426h                           ; 74 05
     mov ax, 0017fh                            ; b8 7f 01
-    jmp short 02414h                          ; eb 03
+    jmp short 02429h                          ; eb 03
     mov ax, 00186h                            ; b8 86 01
     push ax                                   ; 50
@@ -2544,5 +2574,5 @@
     push 0018dh                               ; 68 8d 01
     push strict byte 00002h                   ; 6a 02
-    call 0190dh                               ; e8 eb f4
+    call 01922h                               ; e8 eb f4
     add sp, strict byte 00008h                ; 83 c4 08
     xor di, di                                ; 31 ff
@@ -2550,11 +2580,11 @@
     inc di                                    ; 47
     test ax, ax                               ; 85 c0
-    je short 0243eh                           ; 74 0e
+    je short 02453h                           ; 74 0e
     push ax                                   ; 50
     push 00198h                               ; 68 98 01
     push strict byte 00002h                   ; 6a 02
-    call 0190dh                               ; e8 d4 f4
+    call 01922h                               ; e8 d4 f4
     add sp, strict byte 00006h                ; 83 c4 06
-    jmp short 02427h                          ; eb e9
+    jmp short 0243ch                          ; eb e9
     push dword [bp-030h]                      ; 66 ff 76 d0
     movzx ax, byte [bp-012h]                  ; 0f b6 46 ee
@@ -2562,11 +2592,11 @@
     push 0019bh                               ; 68 9b 01
     push strict byte 00002h                   ; 6a 02
-    call 0190dh                               ; e8 be f4
+    call 01922h                               ; e8 be f4
     add sp, strict byte 0000ah                ; 83 c4 0a
-    jmp near 024dbh                           ; e9 86 00
+    jmp near 024f0h                           ; e9 86 00
     cmp byte [bp-008h], 000h                  ; 80 7e f8 00
-    je short 02460h                           ; 74 05
+    je short 02475h                           ; 74 05
     mov ax, 0017fh                            ; b8 7f 01
-    jmp short 02463h                          ; eb 03
+    jmp short 02478h                          ; eb 03
     mov ax, 00186h                            ; b8 86 01
     push ax                                   ; 50
@@ -2575,5 +2605,5 @@
     push 0018dh                               ; 68 8d 01
     push strict byte 00002h                   ; 6a 02
-    call 0190dh                               ; e8 9c f4
+    call 01922h                               ; e8 9c f4
     add sp, strict byte 00008h                ; 83 c4 08
     xor di, di                                ; 31 ff
@@ -2581,11 +2611,11 @@
     inc di                                    ; 47
     test ax, ax                               ; 85 c0
-    je short 0248dh                           ; 74 0e
+    je short 024a2h                           ; 74 0e
     push ax                                   ; 50
     push 00198h                               ; 68 98 01
     push strict byte 00002h                   ; 6a 02
-    call 0190dh                               ; e8 85 f4
+    call 01922h                               ; e8 85 f4
     add sp, strict byte 00006h                ; 83 c4 06
-    jmp short 02476h                          ; eb e9
+    jmp short 0248bh                          ; eb e9
     movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
     imul ax, ax, strict byte 00018h           ; 6b c0 18
@@ -2593,20 +2623,20 @@
     add bx, ax                                ; 01 c3
     cmp byte [es:bx+01fh], 005h               ; 26 80 7f 1f 05
-    jne short 024aah                          ; 75 0a
+    jne short 024bfh                          ; 75 0a
     movzx ax, byte [bp-012h]                  ; 0f b6 46 ee
     push ax                                   ; 50
     push 001bbh                               ; 68 bb 01
-    jmp short 024b2h                          ; eb 08
+    jmp short 024c7h                          ; eb 08
     movzx ax, byte [bp-012h]                  ; 0f b6 46 ee
     push ax                                   ; 50
     push 001d5h                               ; 68 d5 01
     push strict byte 00002h                   ; 6a 02
-    call 0190dh                               ; e8 56 f4
+    call 01922h                               ; e8 56 f4
     add sp, strict byte 00006h                ; 83 c4 06
-    jmp short 024dbh                          ; eb 1f
+    jmp short 024f0h                          ; eb 1f
     cmp byte [bp-008h], 000h                  ; 80 7e f8 00
-    je short 024c7h                           ; 74 05
+    je short 024dch                           ; 74 05
     mov ax, 0017fh                            ; b8 7f 01
-    jmp short 024cah                          ; eb 03
+    jmp short 024dfh                          ; eb 03
     mov ax, 00186h                            ; b8 86 01
     push ax                                   ; 50
@@ -2615,9 +2645,9 @@
     push 001e7h                               ; 68 e7 01
     push strict byte 00002h                   ; 6a 02
-    call 0190dh                               ; e8 35 f4
+    call 01922h                               ; e8 35 f4
     add sp, strict byte 00008h                ; 83 c4 08
     inc byte [bp-00eh]                        ; fe 46 f2
     cmp byte [bp-00eh], 008h                  ; 80 7e f2 08
-    jnc short 02532h                          ; 73 4e
+    jnc short 02547h                          ; 73 4e
     movzx bx, byte [bp-00eh]                  ; 0f b6 5e f2
     mov ax, bx                                ; 89 d8
@@ -2647,7 +2677,7 @@
     out DX, AL                                ; ee
     test cl, cl                               ; 84 c9
-    je near 01f9ch                            ; 0f 84 70 fa
+    je near 01fb1h                            ; 0f 84 70 fa
     mov ax, 000b0h                            ; b8 b0 00
-    jmp near 01f9fh                           ; e9 6d fa
+    jmp near 01fb4h                           ; e9 6d fa
     mov al, byte [bp-006h]                    ; 8a 46 fa
     les bx, [bp-028h]                         ; c4 5e d8
@@ -2658,5 +2688,5 @@
     mov dx, strict word 00075h                ; ba 75 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 bc f0
+    call 0160eh                               ; e8 a7 f0
     lea sp, [bp-004h]                         ; 8d 66 fc
     pop di                                    ; 5f
@@ -2664,5 +2694,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-ata_cmd_data_out_:                           ; 0xf2559 LB 0x21a
+ata_cmd_data_out_:                           ; 0xf256e LB 0x21a
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -2693,7 +2723,7 @@
     mov byte [bp-008h], al                    ; 88 46 f8
     cmp AL, strict byte 001h                  ; 3c 01
-    jne short 025adh                          ; 75 07
+    jne short 025c2h                          ; 75 07
     mov word [bp-012h], 00080h                ; c7 46 ee 80 00
-    jmp short 025b2h                          ; eb 05
+    jmp short 025c7h                          ; eb 05
     mov word [bp-012h], 00100h                ; c7 46 ee 00 01
     lea dx, [bx+007h]                         ; 8d 57 07
@@ -2702,5 +2732,5 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 080h                 ; a8 80
-    je short 025cbh                           ; 74 0f
+    je short 025e0h                           ; 74 0f
     mov dx, word [bp-00ch]                    ; 8b 56 f4
     add dx, strict byte 00006h                ; 83 c2 06
@@ -2708,5 +2738,5 @@
     out DX, AL                                ; ee
     mov dx, strict word 00001h                ; ba 01 00
-    jmp near 0276ah                           ; e9 9f 01
+    jmp near 0277fh                           ; e9 9f 01
     mov es, [bp-00ah]                         ; 8e 46 f6
     mov ax, word [es:di]                      ; 26 8b 05
@@ -2725,11 +2755,11 @@
     mov ax, word [bp-010h]                    ; 8b 46 f0
     test ax, ax                               ; 85 c0
-    jne short 02669h                          ; 75 67
+    jne short 0267eh                          ; 75 67
     mov dx, word [bp-01eh]                    ; 8b 56 e2
     add dx, word [bp-00eh]                    ; 03 56 f2
     adc ax, word [bp-01ch]                    ; 13 46 e4
     cmp ax, 01000h                            ; 3d 00 10
-    jnbe short 02612h                         ; 77 02
-    jne short 0263dh                          ; 75 2b
+    jnbe short 02627h                         ; 77 02
+    jne short 02652h                          ; 75 2b
     mov ax, word [bp-01ch]                    ; 8b 46 e4
     xor al, al                                ; 30 c0
@@ -2756,5 +2786,5 @@
     shr word [bp-01ch], 1                     ; d1 6e e4
     rcr word [bp-01eh], 1                     ; d1 5e e2
-    loop 02648h                               ; e2 f8
+    loop 0265dh                               ; e2 f8
     mov ax, word [bp-01eh]                    ; 8b 46 e2
     mov word [bp-016h], ax                    ; 89 46 ea
@@ -2785,7 +2815,7 @@
     out DX, AL                                ; ee
     cmp byte [bp-006h], 000h                  ; 80 7e fa 00
-    je short 0269fh                           ; 74 05
+    je short 026b4h                           ; 74 05
     mov ax, 000b0h                            ; b8 b0 00
-    jmp short 026a2h                          ; eb 03
+    jmp short 026b7h                          ; eb 03
     mov ax, 000a0h                            ; b8 a0 00
     movzx dx, byte [bp-014h]                  ; 0f b6 56 ec
@@ -2802,7 +2832,7 @@
     mov dl, al                                ; 88 c2
     test AL, strict byte 080h                 ; a8 80
-    jne short 026b3h                          ; 75 f4
+    jne short 026c8h                          ; 75 f4
     test AL, strict byte 001h                 ; a8 01
-    je short 026d2h                           ; 74 0f
+    je short 026e7h                           ; 74 0f
     mov dx, word [bp-00ch]                    ; 8b 56 f4
     add dx, strict byte 00006h                ; 83 c2 06
@@ -2810,7 +2840,7 @@
     out DX, AL                                ; ee
     mov dx, strict word 00002h                ; ba 02 00
-    jmp near 0276ah                           ; e9 98 00
+    jmp near 0277fh                           ; e9 98 00
     test dl, 008h                             ; f6 c2 08
-    jne short 026e6h                          ; 75 0f
+    jne short 026fbh                          ; 75 0f
     mov dx, word [bp-00ch]                    ; 8b 56 f4
     add dx, strict byte 00006h                ; 83 c2 06
@@ -2818,8 +2848,8 @@
     out DX, AL                                ; ee
     mov dx, strict word 00003h                ; ba 03 00
-    jmp near 0276ah                           ; e9 84 00
+    jmp near 0277fh                           ; e9 84 00
     sti                                       ; fb
     cmp si, 0f800h                            ; 81 fe 00 f8
-    jc short 026fah                           ; 72 0d
+    jc short 0270fh                           ; 72 0d
     sub si, 00800h                            ; 81 ee 00 08
     mov ax, word [bp-018h]                    ; 8b 46 e8
@@ -2827,5 +2857,5 @@
     mov word [bp-018h], ax                    ; 89 46 e8
     cmp byte [bp-008h], 001h                  ; 80 7e f8 01
-    jne short 0270eh                          ; 75 0e
+    jne short 02723h                          ; 75 0e
     mov dx, bx                                ; 89 da
     mov cx, word [bp-012h]                    ; 8b 4e ee
@@ -2833,5 +2863,5 @@
     db  0f3h, 066h, 026h, 06fh
     ; rep es outsd                              ; f3 66 26 6f
-    jmp short 02719h                          ; eb 0b
+    jmp short 0272eh                          ; eb 0b
     mov dx, bx                                ; 89 da
     mov cx, word [bp-012h]                    ; 8b 4e ee
@@ -2848,10 +2878,10 @@
     mov dl, al                                ; 88 c2
     test AL, strict byte 080h                 ; a8 80
-    jne short 02723h                          ; 75 f4
+    jne short 02738h                          ; 75 f4
     cmp word [bp-00eh], strict byte 00000h    ; 83 7e f2 00
-    jne short 02749h                          ; 75 14
+    jne short 0275eh                          ; 75 14
     and AL, strict byte 0e9h                  ; 24 e9
     cmp AL, strict byte 040h                  ; 3c 40
-    je short 0275fh                           ; 74 24
+    je short 02774h                           ; 74 24
     mov dx, word [bp-00ch]                    ; 8b 56 f4
     add dx, strict byte 00006h                ; 83 c2 06
@@ -2859,9 +2889,9 @@
     out DX, AL                                ; ee
     mov dx, strict word 00006h                ; ba 06 00
-    jmp short 0276ah                          ; eb 21
+    jmp short 0277fh                          ; eb 21
     mov al, dl                                ; 88 d0
     and AL, strict byte 0c9h                  ; 24 c9
     cmp AL, strict byte 048h                  ; 3c 48
-    je short 026e7h                           ; 74 96
+    je short 026fch                           ; 74 96
     mov dx, word [bp-00ch]                    ; 8b 56 f4
     add dx, strict byte 00006h                ; 83 c2 06
@@ -2869,5 +2899,5 @@
     out DX, AL                                ; ee
     mov dx, strict word 00007h                ; ba 07 00
-    jmp short 0276ah                          ; eb 0b
+    jmp short 0277fh                          ; eb 0b
     mov dx, word [bp-00ch]                    ; 8b 56 f4
     add dx, strict byte 00006h                ; 83 c2 06
@@ -2881,5 +2911,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-@ata_read_sectors:                           ; 0xf2773 LB 0x7a
+@ata_read_sectors:                           ; 0xf2788 LB 0x7a
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -2895,10 +2925,10 @@
     mov ax, word [es:si+012h]                 ; 26 8b 44 12
     test ax, ax                               ; 85 c0
-    je short 027a1h                           ; 74 0d
+    je short 027b6h                           ; 74 0d
     movzx di, bl                              ; 0f b6 fb
     imul di, di, strict byte 00018h           ; 6b ff 18
     mov [bp-006h], es                         ; 8c 46 fa
     add di, si                                ; 01 f7
-    jmp short 027cdh                          ; eb 2c
+    jmp short 027e2h                          ; eb 2c
     mov di, word [es:si]                      ; 26 8b 3c
     add di, cx                                ; 01 cf
@@ -2906,11 +2936,11 @@
     adc ax, word [es:si+002h]                 ; 26 13 44 02
     cmp ax, 01000h                            ; 3d 00 10
-    jnbe short 027b4h                         ; 77 02
-    jne short 027c0h                          ; 75 0c
+    jnbe short 027c9h                         ; 77 02
+    jne short 027d5h                          ; 75 0c
     mov bx, strict word 00024h                ; bb 24 00
     mov ax, si                                ; 89 f0
     mov dx, es                                ; 8c c2
-    call 01ceah                               ; e8 2c f5
-    jmp short 027e4h                          ; eb 24
+    call 01cffh                               ; e8 2c f5
+    jmp short 027f9h                          ; eb 24
     movzx ax, bl                              ; 0f b6 c3
     imul ax, ax, strict byte 00018h           ; 6b c0 18
@@ -2922,5 +2952,5 @@
     mov ax, si                                ; 89 f0
     mov dx, es                                ; 8c c2
-    call 01ceah                               ; e8 0f f5
+    call 01cffh                               ; e8 0f f5
     mov es, [bp-006h]                         ; 8e 46 fa
     mov word [es:di+024h], 00200h             ; 26 c7 45 24 00 02
@@ -2930,5 +2960,5 @@
     pop bp                                    ; 5d
     retn 00004h                               ; c2 04 00
-@ata_write_sectors:                          ; 0xf27ed LB 0x3d
+@ata_write_sectors:                          ; 0xf2802 LB 0x3d
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -2937,10 +2967,10 @@
     mov cx, word [es:si+00ah]                 ; 26 8b 4c 0a
     cmp word [es:si+012h], strict byte 00000h ; 26 83 7c 12 00
-    je short 0280bh                           ; 74 0c
+    je short 02820h                           ; 74 0c
     mov bx, strict word 00030h                ; bb 30 00
     mov ax, si                                ; 89 f0
     mov dx, es                                ; 8c c2
-    call 02559h                               ; e8 50 fd
-    jmp short 02822h                          ; eb 17
+    call 0256eh                               ; e8 50 fd
+    jmp short 02837h                          ; eb 17
     xor ax, ax                                ; 31 c0
     mov dx, word [es:si]                      ; 26 8b 14
@@ -2948,13 +2978,13 @@
     adc ax, word [es:si+002h]                 ; 26 13 44 02
     cmp ax, 01000h                            ; 3d 00 10
-    jnbe short 0281dh                         ; 77 02
-    jne short 027ffh                          ; 75 e2
+    jnbe short 02832h                         ; 77 02
+    jne short 02814h                          ; 75 e2
     mov bx, strict word 00034h                ; bb 34 00
-    jmp short 02802h                          ; eb e0
+    jmp short 02817h                          ; eb e0
     lea sp, [bp-002h]                         ; 8d 66 fe
     pop si                                    ; 5e
     pop bp                                    ; 5d
     retn 00004h                               ; c2 04 00
-ata_cmd_packet_:                             ; 0xf282a LB 0x2e8
+ata_cmd_packet_:                             ; 0xf283f LB 0x2e8
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -2967,5 +2997,5 @@
     mov dx, strict word 0000eh                ; ba 0e 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 db ed
+    call 0161ch                               ; e8 c6 ed
     mov word [bp-012h], 00122h                ; c7 46 ee 22 01
     mov word [bp-00eh], ax                    ; 89 46 f2
@@ -2976,18 +3006,18 @@
     mov byte [bp-006h], ah                    ; 88 66 fa
     cmp byte [bp+00ah], 002h                  ; 80 7e 0a 02
-    jne short 0287ch                          ; 75 1f
-    mov bx, 00da6h                            ; bb a6 0d
+    jne short 02891h                          ; 75 1f
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 64 f0
+    call 018e1h                               ; e8 64 f0
     push 00201h                               ; 68 01 02
     push 00210h                               ; 68 10 02
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 9a f0
+    call 01922h                               ; e8 9a f0
     add sp, strict byte 00006h                ; 83 c4 06
     mov dx, strict word 00001h                ; ba 01 00
-    jmp near 02b07h                           ; e9 8b 02
+    jmp near 02b1ch                           ; e9 8b 02
     test byte [bp+004h], 001h                 ; f6 46 04 01
-    jne short 02876h                          ; 75 f4
+    jne short 0288bh                          ; 75 f4
     xor ah, ah                                ; 30 e4
     imul ax, ax, strict byte 00006h           ; 6b c0 06
